#include <stdio.h>

#ifndef _SBC_PARSER_H_
#define _SBC_PARSER_H_

/// Token for expected/acceptable EOF
#define TOKEN_EOF          -1
/// Token for BOINK
#define TOKEN_BOINK         1
/// Token for SPAM
#define TOKEN_SPAM          2
/// Token for CHEESE
#define TOKEN_CHEESE        3
/// Token for bad/unexpected character
#define BAD_CHAR            4
/// Token for premature EOF (EOF while state machine is in the middle of a token)
#define PREMATURE_EOF       5

/// Current line number (useful for reporting error conditions)
extern int PARSER_LINE;
/// Current column (useful for reporting error conditions)
extern int PARSER_COLUMN;
/// Last read character (useful for BAD_CHAR token)
extern int BAD_CHAR_CODE;
/// Current state of the finite state machine (useful only for debugging)
extern int parser_mode;

void init();
int getNextToken(FILE *in);

#endif
