#include "writer.h"

/// Text string for SPAM
#define WRITE_SPAM	 "Spam"
/// Text string for BOINK
#define WRITE_BOINK	"Boink"
/// Text string for CHEESE
#define WRITE_CHEESE	"Cheese"

// BOINK is zero, right?
#define ZERO			WRITE_BOINK
#define ONE			WRITE_SPAM

/**
 * Take an input binary file (typically ASCII data) and output it using
 * SpamBoinkCheese encoding.  The output can be 7 or 8 bits, depending on
 * the parameter.
 */
void write(FILE *in, FILE *out, int bits) {
	int c, i;
	int bit;
	int mask;
#ifdef DEBUG
	printf("Bits: %d\n", bits);
#endif
	while (!feof(in)) {
		// Read the next character
		c = fgetc(in);
		if (c == EOF)
			break;
		// For each bit
		mask = 1 << (bits - 1);
		while (mask != 0) {
#ifdef DEBUG
			printf("%00x %00x %00x\n", c, mask, (c & mask));
#endif
			// Get next bit
			bit = ((c & mask) == mask);
			// Write bit
			if (bit == 0)
				fprintf(out, "%s", ZERO);
			else
				fprintf(out, "%s", ONE);
			mask = mask >> 1;
		}
		// Write stop
		fprintf(out, "%s", WRITE_CHEESE);
	}
	fprintf(out, "%s%s%s%s", WRITE_CHEESE, WRITE_CHEESE, WRITE_CHEESE, WRITE_CHEESE);
}
